#pragma once

#include <QJsonObject>

class Config {
public:
	struct StageConfig {
		StageConfig();
		StageConfig(const QJsonObject&);
		operator QJsonObject() const;

		std::string champ;
		bool enabled;
	};

	struct RootConfig {
		RootConfig();
		RootConfig(const QJsonObject&);
		operator QJsonObject() const;

		StageConfig prepick;
		StageConfig ban;
		StageConfig pick;
		bool enabledAutoAccept;
	};

	Config();
	~Config();

	bool load();
	void save();

	RootConfig& getConfig();
private:
	std::string configFolderPath;
	std::string configFilePath;
	RootConfig root;
};
