#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <thread>

#include "config.h"
#include "datadragon.h"
#include "lolautoaccept.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow {
	Q_OBJECT

public:
	MainWindow(LolAutoAccept& lolaa, QWidget *parent = nullptr);
	~MainWindow();

protected:
	virtual void closeEvent(QCloseEvent* event) override;

private slots:
	void toggleMainswitch(bool);
	void aatoggled(bool);
	void pptoggled(bool);
	void ppedited(const QString&);
	void bantoggled(bool);
	void banedited(const QString&);
	void picktoggled(bool);
	void pickedited(const QString&);

private:
	// returns empty string on no match
	const DataDragon::ChampData& getBestMatchingChamp(const std::string& name);

	Ui::MainWindow *ui;
	LolAutoAccept& lolaa;
	std::thread lolaathread;
	DataDragon dd;
	Config conf;
};

#endif // MAINWINDOW_H
