#pragma once

#include <cstdint>
#include <vector>

class ScaleableInputs {
public:
	struct Point {
		uint32_t x;
		uint32_t y;
	};

private:
	double xScale = 1;
	double yScale = 1;
	double xOffset = 0;
	double yOffset = 0;

	std::vector<Point> points;

public:

	void addPoint(Point p);
	void setScale(double x, double y);
	void setOffset(double x, double y);

	Point get(uint32_t nr) const;

};