#include "datadragonimagecache.h"

#include <QFile>

#include <Log.h>

#include "files.h"

DataDragonImageCache::DataDragonImageCache(const std::string& folderextra, const std::string& imageext) : imageext(imageext) {
	// init cache dir
	cacheDir = getHome() + ".cache/lolautoaccept/" + folderextra + "/";

	mkdirs(cacheDir);
}
DataDragonImageCache::~DataDragonImageCache() {}

cv::Mat DataDragonImageCache::getImage(const std::string& name) {
	auto img = cv::imread(getFilepath(name));
	if(!img.empty())
		cv::cvtColor(img, img, cv::COLOR_BGR2RGB);
	return img;
}

void DataDragonImageCache::addImageRaw(const QByteArray& arr, const std::string& name) {
	QFile file(QString::fromStdString(getFilepath(name)));
	file.open(QIODevice::WriteOnly);
	file.write(arr);
}

std::string DataDragonImageCache::getFilepath(const std::string& name) const {
	return cacheDir + name + imageext;
}
