#include "fakescreen.h"

FakeScreen::FakeScreen(int xoffset, int yoffset, int xsize, int ysize) : ScreenShot(),
	xoffset(xoffset), yoffset(yoffset), xsize(xsize), ysize(ysize) {
}

FakeScreen::~FakeScreen() {}


void FakeScreen::take(cv::Mat& cvimg) {
	// take screenshot from entire screen using base class
	cv::Mat entireScreen;
	ScreenShot::take(entireScreen);

	// only return part of the screenshot
	entireScreen({yoffset, yoffset + ysize}, {xoffset, xoffset + xsize}).copyTo(cvimg);
}

void FakeScreen::operator() (cv::Mat& cvimg) {
	take(cvimg);
}


int FakeScreen::getXOffset() const {
	return xoffset;
}

int FakeScreen::getYOffset() const {
	return yoffset;
}

double FakeScreen::getXScale() const {
	return xsize / (double) DEFAULTWIDTH;
}

double FakeScreen::getYScale() const {
	return ysize / (double) DEFAULTHEIGHT;
}