#include "scaleableinputs.h"

#include <Log.h>

void ScaleableInputs::addPoint(Point p) {
	points.push_back(p);
}

void ScaleableInputs::setScale(double x, double y) {
	xScale = x;
	yScale = y;
}

void ScaleableInputs::setOffset(double x, double y) {
	xOffset = x;
	yOffset = y;
}

ScaleableInputs::Point ScaleableInputs::get(uint32_t nr) const {
	Point p = points.at(nr);

	Log::debug << "scaling: " << p.x << " " << p.y << " with: " << xOffset << " " << yOffset << " scale: " << xScale << " " << yScale;

	return {(uint32_t) ((p.x * xScale) + xOffset), (uint32_t) ((p.y * yScale) + yOffset)};
}